public class evaldiff {
	public static void check_futile_score_quies(tree_t ptree, int move,
			int old_val, int new_val, int turn) {
		final int ifrom = bitop.I2From(move);
		int fsp, fmt, ipc_cap;

		old_val /= def.FV_SCALE;
		new_val /= def.FV_SCALE;

		if (bitop.I2PieceMove(move) == def.king) {
			fmt = new_val;
			fsp = new_val - old_val;

			if (turn > 0) {
				fmt += ptree.posi.material;
				ipc_cap = -(int) bitop.UToCap(move);
			} else {
				fmt -= ptree.posi.material;
				ipc_cap = (int) bitop.UToCap(move);
			}

			if (ipc_cap > 0) {
				fmt -= data.p_value_ex[15 + ipc_cap];
				fsp -= estimate_score_diff(ptree, move, turn);
				if (fsp > data.fmg_cap_king) {
					data.fmg_cap_king = fsp;
				}
			} else if (fsp > data.fmg_misc_king) {
				data.fmg_misc_king = fsp;
			}

			if (fmt > data.fmg_mt) {
				data.fmg_mt = fmt;
			}
		} else {
			fsp = new_val - old_val - estimate_score_diff(ptree, move, turn);
			if (turn > 0) {
				fmt = new_val + ptree.posi.material;
				ipc_cap = -(int) bitop.UToCap(move);
			} else {
				fmt = new_val - ptree.posi.material;
				ipc_cap = (int) bitop.UToCap(move);
			}
			if (ifrom >= def.nsquare) {
				if (fsp > data.fmg_drop) {
					data.fmg_drop = fsp;
				}
			} else {
				if (bitop.I2IsPromote(move) > 0) {
					fmt -= data.p_value_pm[7 + bitop.I2PieceMove(move)];
				}

				if (ipc_cap > 0) {
					fmt -= data.p_value_ex[15 + ipc_cap];
					if (fsp > data.fmg_cap) {
						data.fmg_cap = fsp;
					}
				} else if (fsp > data.fmg_misc) {
					data.fmg_misc = fsp;
				}
			}

			if (fmt > data.fmg_mt) {
				data.fmg_mt = fmt;
			}
		}
	}

	public static int eval_max_score(tree_t ptree, int move, int value,
			int turn, int diff) {
		int score_mt, score_sp, ipc_cap;

		value /= def.FV_SCALE;

		if (bitop.I2From(move) >= def.nsquare) {
			score_sp = value + diff + data.fmg_drop
					+ ((data.p_value_ex[15 + def.dragon] * 2) / 16);
			score_mt = (turn > 0 ? -ptree.posi.material : ptree.posi.material)
					+ data.fmg_mt
					+ ((data.p_value_ex[15 + def.dragon] * 8) / 16);
		} else {
			score_sp = diff + value;
			score_mt = data.fmg_mt
					+ ((data.p_value_ex[15 + def.dragon] * 8) / 16);
			if (turn > 0) {
				score_mt -= ptree.posi.material;
				ipc_cap = -(int) bitop.UToCap(move);
			} else {
				score_mt += ptree.posi.material;
				ipc_cap = (int) bitop.UToCap(move);
			}
			if (bitop.I2PieceMove(move) == def.king) {
				if (ipc_cap > 0) {
					score_mt += data.p_value_ex[15 + ipc_cap];
					score_sp += data.fmg_cap_king;
				} else {
					score_sp += data.fmg_misc_king;
				}
				score_sp += ((data.p_value_ex[15 + def.dragon] * 3) / 16);
			} else {
				if (ipc_cap > 0) {
					score_mt += data.p_value_ex[15 + ipc_cap];
					score_sp += data.fmg_cap;
				} else {
					score_sp += data.fmg_misc;
				}

				if (bitop.I2IsPromote(move) > 0) {
					score_mt += data.p_value_pm[7 + bitop.I2PieceMove(move)];
				}

				score_sp += ((data.p_value_ex[15 + def.dragon] * 2) / 16);
			}
		}
		return score_mt < score_sp ? score_mt : score_sp;
	}

	public static int estimate_score_diff(tree_t ptree, int move, int turn) {
		final int ibk = ptree.posi.isquare_b_king;
		final int iwk = bitop.Inv(ptree.posi.isquare_w_king);
		final int ifrom = bitop.I2From(move);
		final int ito = bitop.I2To(move);
		int diff, ipc_move, ipc_cap, ipro_pc_move;

		if (bitop.I2PieceMove(move) == def.king) {
			ipc_cap = (int) bitop.UToCap(move);
			if (ipc_cap > 0) {
				diff = -(int) bitop.PcOnSq(ibk, def.aikpp[15 + ipc_cap] + ito);
				diff += (int) bitop.PcOnSq(iwk,
						def.aikpp[15 - ipc_cap] + bitop.Inv(ito));
				diff /= def.FV_SCALE;
				if (turn > 0) {
					diff -= data.p_value_ex[15 + ipc_cap];
				} else {
					diff += data.p_value_ex[15 - ipc_cap];
				}
			} else {
				diff = 0;
			}
		} else if (ifrom >= def.nsquare) {
			ipc_move = turn > 0 ? -(int) bitop.From2Drop(ifrom) : (int) bitop
					.From2Drop(ifrom);
			diff = (int) bitop.PcOnSq(ibk, def.aikpp[15 + ipc_move] + ito);
			diff -= (int) bitop.PcOnSq(iwk,
					def.aikpp[15 - ipc_move] + bitop.Inv(ito));
			diff /= def.FV_SCALE;
		} else {
			if (turn > 0) {
				ipc_move = -(int) bitop.I2PieceMove(move);
				ipc_cap = (int) bitop.UToCap(move);
				ipro_pc_move = ipc_move - def.promote;
			} else {
				ipc_move = (int) bitop.I2PieceMove(move);
				ipc_cap = -(int) bitop.UToCap(move);
				ipro_pc_move = ipc_move + def.promote;
			}
			if (bitop.I2IsPromote(move) > 0 && ipc_cap > 0) {
				diff = -(int) bitop.PcOnSq(ibk, def.aikpp[15 + ipc_move]
						+ ifrom);
				diff += (int) bitop.PcOnSq(ibk, def.aikpp[15 + ipro_pc_move]
						+ ito);
				diff += -(int) bitop.PcOnSq(ibk, def.aikpp[15 + ipc_cap] + ito);
				diff += (int) bitop.PcOnSq(iwk, def.aikpp[15 - ipc_move]
						+ bitop.Inv(ifrom));
				diff += -(int) bitop.PcOnSq(iwk, def.aikpp[15 - ipro_pc_move]
						+ bitop.Inv(ito));
				diff += (int) bitop.PcOnSq(iwk,
						def.aikpp[15 - ipc_cap] + bitop.Inv(ito));
				diff /= def.FV_SCALE;
				if (turn > 0) {
					diff -= data.p_value_pm[7 + ipc_move];
					diff -= data.p_value_ex[15 + ipc_cap];
				} else {
					diff += data.p_value_pm[7 + ipc_move];
					diff += data.p_value_ex[15 + ipc_cap];
				}
			} else if (ipc_cap > 0) {
				diff = -(int) bitop.PcOnSq(ibk, def.aikpp[15 + ipc_move]
						+ ifrom);
				diff += (int) bitop.PcOnSq(ibk, def.aikpp[15 + ipc_move] + ito);
				diff += -(int) bitop.PcOnSq(ibk, def.aikpp[15 + ipc_cap] + ito);
				diff += (int) bitop.PcOnSq(iwk, def.aikpp[15 - ipc_move]
						+ bitop.Inv(ifrom));
				diff += -(int) bitop.PcOnSq(iwk, def.aikpp[15 - ipc_move]
						+ bitop.Inv(ito));
				diff += (int) bitop.PcOnSq(iwk,
						def.aikpp[15 - ipc_cap] + bitop.Inv(ito));
				diff /= def.FV_SCALE;
				diff += turn > 0 ? -data.p_value_ex[15 + ipc_cap]
						: data.p_value_ex[15 + ipc_cap];
			} else if (bitop.I2IsPromote(move) > 0) {
				diff = -(int) bitop.PcOnSq(ibk, def.aikpp[15 + ipc_move]
						+ ifrom);
				diff += (int) bitop.PcOnSq(ibk, def.aikpp[15 + ipro_pc_move]
						+ ito);
				diff += (int) bitop.PcOnSq(iwk, def.aikpp[15 - ipc_move]
						+ bitop.Inv(ifrom));
				diff += -(int) bitop.PcOnSq(iwk, def.aikpp[15 - ipro_pc_move]
						+ bitop.Inv(ito));
				diff /= def.FV_SCALE;
				diff += turn > 0 ? -data.p_value_pm[7 + ipc_move]
						: data.p_value_pm[7 + ipc_move];
			} else {
				diff = -(int) bitop.PcOnSq(ibk, def.aikpp[15 + ipc_move]
						+ ifrom);
				diff += (int) bitop.PcOnSq(ibk, def.aikpp[15 + ipc_move] + ito);
				diff += (int) bitop.PcOnSq(iwk, def.aikpp[15 - ipc_move]
						+ bitop.Inv(ifrom));
				diff += -(int) bitop.PcOnSq(iwk, def.aikpp[15 - ipc_move]
						+ bitop.Inv(ito));
				diff /= def.FV_SCALE;
			}
		}

		if (turn > 0) {
			diff = -diff;
		}

		return diff;
	}
}
