public class gencap {
	public static int b_gen_captures(tree_t ptree, int moveidx) {
		bitboard_t bb_movable = new bitboard_t(), bb_capture = new bitboard_t(), bb_piece = new bitboard_t(), bb_desti = new bitboard_t();
		int utemp;
		int ito, ifrom;

		bb_capture = new bitboard_t(ptree.posi.w_occupied);
		bitop.BBNot(bb_movable, ptree.posi.b_occupied);

		bb_desti.p[0] = ptree.posi.b_pawn_attacks.p[0] & bb_movable.p[0];
		bb_desti.p[1] = ptree.posi.b_pawn_attacks.p[1] & bb_capture.p[1];
		bb_desti.p[2] = ptree.posi.b_pawn_attacks.p[2] & bb_capture.p[2];
		while (bitop.BBToU(bb_desti) > 0) {
			ito = bitop.LastOne(bb_desti);
			bitop.Xor(ito, bb_desti);

			ifrom = ito + 9;
			utemp = (bitop.To2Move(ito) | bitop.From2Move(ifrom)
					| bitop.Cap2Move(-ptree.posi.asquare[ito]) | bitop
					.Piece2Move(def.pawn));
			if (ito < def.A6) {
				utemp |= def.FLAG_PROMO;
			}
			ptree.amove[moveidx++] = utemp;
		}

		bb_piece = new bitboard_t(ptree.posi.b_silver);
		while (bitop.BBTest(bb_piece)) {
			ifrom = bitop.LastOne(bb_piece);
			bitop.Xor(ifrom, bb_piece);

			bitop.BBAnd(bb_desti, bb_capture, data.abb_b_silver_attacks[ifrom]);
			while (bitop.BBTest(bb_desti)) {
				ito = bitop.LastOne(bb_desti);
				bitop.Xor(ito, bb_desti);

				utemp = (bitop.To2Move(ito) | bitop.From2Move(ifrom)
						| bitop.Cap2Move(-ptree.posi.asquare[ito]) | bitop
						.Piece2Move(def.silver));
				if (ito < def.A6 || ifrom < def.A6) {
					ptree.amove[moveidx++] = utemp | def.FLAG_PROMO;
				}
				ptree.amove[moveidx++] = utemp;
			}
		}

		bb_piece = new bitboard_t(ptree.posi.b_tgold);
		while (bitop.BBTest(bb_piece)) {
			ifrom = bitop.LastOne(bb_piece);
			bitop.Xor(ifrom, bb_piece);

			bitop.BBAnd(bb_desti, bb_capture, data.abb_b_gold_attacks[ifrom]);
			while (bitop.BBTest(bb_desti)) {
				ito = bitop.LastOne(bb_desti);
				bitop.Xor(ito, bb_desti);

				ptree.amove[moveidx++] = (bitop.To2Move(ito)
						| bitop.From2Move(ifrom)
						| bitop.Cap2Move(-ptree.posi.asquare[ito]) | bitop
						.Piece2Move(ptree.posi.asquare[ifrom]));
			}
		}

		ifrom = ptree.posi.isquare_b_king;
		bitop.BBAnd(bb_desti, bb_capture, data.abb_king_attacks[ifrom]);
		while (bitop.BBTest(bb_desti)) {
			ito = bitop.LastOne(bb_desti);
			bitop.Xor(ito, bb_desti);

			ptree.amove[moveidx++] = (bitop.To2Move(ito)
					| bitop.From2Move(ifrom)
					| bitop.Cap2Move(-ptree.posi.asquare[ito]) | bitop
					.Piece2Move(def.king));
		}

		bb_piece = new bitboard_t(ptree.posi.b_bishop);
		while (bitop.BBTest(bb_piece)) {
			ifrom = bitop.LastOne(bb_piece);
			bitop.Xor(ifrom, bb_piece);

			bitop.AttackBishop(bb_desti, ifrom, ptree);
			bb_desti.p[0] &= bb_movable.p[0];
			if (ifrom < def.A6) {
				bb_desti.p[1] &= bb_movable.p[1];
				bb_desti.p[2] &= bb_movable.p[2];
			} else {
				bb_desti.p[1] &= bb_capture.p[1];
				bb_desti.p[2] &= bb_capture.p[2];
			}

			while (bitop.BBTest(bb_desti)) {
				ito = bitop.LastOne(bb_desti);
				bitop.Xor(ito, bb_desti);

				utemp = (bitop.To2Move(ito) | bitop.From2Move(ifrom)
						| bitop.Cap2Move(-ptree.posi.asquare[ito]) | bitop
						.Piece2Move(def.bishop));
				if (ito < def.A6 || ifrom < def.A6) {
					utemp |= def.FLAG_PROMO;
				}
				ptree.amove[moveidx++] = utemp;
			}
		}

		bb_piece = new bitboard_t(ptree.posi.b_rook);
		while (bitop.BBTest(bb_piece)) {
			ifrom = bitop.LastOne(bb_piece);
			bitop.Xor(ifrom, bb_piece);

			bitop.AttackRook(bb_desti, ifrom, ptree);
			bb_desti.p[0] &= bb_movable.p[0];
			if (ifrom < def.A6) {
				bb_desti.p[1] &= bb_movable.p[1];
				bb_desti.p[2] &= bb_movable.p[2];
			} else {
				bb_desti.p[1] &= bb_capture.p[1];
				bb_desti.p[2] &= bb_capture.p[2];
			}

			while (bitop.BBTest(bb_desti)) {
				ito = bitop.LastOne(bb_desti);
				bitop.Xor(ito, bb_desti);

				utemp = (bitop.To2Move(ito) | bitop.From2Move(ifrom)
						| bitop.Cap2Move(-ptree.posi.asquare[ito]) | bitop
						.Piece2Move(def.rook));
				if (ito < def.A6 || ifrom < def.A6) {
					utemp |= def.FLAG_PROMO;
				}
				ptree.amove[moveidx++] = utemp;
			}
		}

		bb_piece = new bitboard_t(ptree.posi.b_horse);
		while (bitop.BBTest(bb_piece)) {
			ifrom = bitop.LastOne(bb_piece);
			bitop.Xor(ifrom, bb_piece);

			bitop.AttackHorse(bb_desti, ifrom, ptree);
			bitop.BBAnd(bb_desti, bb_desti, bb_capture);
			while (bitop.BBTest(bb_desti)) {
				ito = bitop.LastOne(bb_desti);
				bitop.Xor(ito, bb_desti);

				ptree.amove[moveidx++] = (bitop.To2Move(ito)
						| bitop.From2Move(ifrom)
						| bitop.Cap2Move(-ptree.posi.asquare[ito]) | bitop
						.Piece2Move(def.horse));
			}
		}

		bb_piece = new bitboard_t(ptree.posi.b_dragon);
		while (bitop.BBTest(bb_piece)) {
			ifrom = bitop.LastOne(bb_piece);
			bitop.Xor(ifrom, bb_piece);

			bitop.AttackDragon(bb_desti, ifrom, ptree);
			bitop.BBAnd(bb_desti, bb_desti, bb_capture);
			while (bitop.BBTest(bb_desti)) {
				ito = bitop.LastOne(bb_desti);
				bitop.Xor(ito, bb_desti);

				ptree.amove[moveidx++] = (bitop.To2Move(ito)
						| bitop.From2Move(ifrom)
						| bitop.Cap2Move(-ptree.posi.asquare[ito]) | bitop
						.Piece2Move(def.dragon));
			}
		}

		bb_piece = new bitboard_t(ptree.posi.b_lance);
		while (bitop.BBTest(bb_piece)) {
			ifrom = bitop.LastOne(bb_piece);
			bitop.Xor(ifrom, bb_piece);

			bb_desti = new bitboard_t(bitop.AttackFile(ifrom, ptree));
			bitop.BBAnd(bb_desti, bb_desti, data.abb_minus_rays[ifrom]);
			bb_desti.p[0] &= bb_movable.p[0];
			bb_desti.p[1] &= bb_capture.p[1];
			bb_desti.p[2] &= bb_capture.p[2];

			while (bitop.BBTest(bb_desti)) {
				ito = bitop.LastOne(bb_desti);
				bitop.Xor(ito, bb_desti);

				utemp = (bitop.To2Move(ito) | bitop.From2Move(ifrom)
						| bitop.Cap2Move(-ptree.posi.asquare[ito]) | bitop
						.Piece2Move(def.lance));
				if (ito < def.A7) {
					ptree.amove[moveidx++] = utemp | def.FLAG_PROMO;
				} else if (ito < def.A6) {
					ptree.amove[moveidx++] = utemp | def.FLAG_PROMO;
					if (bitop.UToCap(utemp) > 0) {
						ptree.amove[moveidx++] = utemp;
					}
				} else {
					ptree.amove[moveidx++] = utemp;
				}
			}
		}

		bb_piece = new bitboard_t(ptree.posi.b_knight);
		while (bitop.BBTest(bb_piece)) {
			ifrom = bitop.LastOne(bb_piece);
			bitop.Xor(ifrom, bb_piece);

			bb_desti = new bitboard_t(data.abb_b_knight_attacks[ifrom]);
			bb_desti.p[0] &= bb_movable.p[0];
			bb_desti.p[1] &= bb_capture.p[1];
			bb_desti.p[2] &= bb_capture.p[2];

			while (bitop.BBTest(bb_desti)) {
				ito = bitop.LastOne(bb_desti);
				bitop.Xor(ito, bb_desti);

				utemp = (bitop.To2Move(ito) | bitop.From2Move(ifrom)
						| bitop.Cap2Move(-ptree.posi.asquare[ito]) | bitop
						.Piece2Move(def.knight));
				if (ito < def.A7) {
					ptree.amove[moveidx++] = utemp | def.FLAG_PROMO;
				} else if (ito < def.A6) {
					ptree.amove[moveidx++] = utemp | def.FLAG_PROMO;
					if (bitop.UToCap(utemp) > 0) {
						ptree.amove[moveidx++] = utemp;
					}
				} else {
					ptree.amove[moveidx++] = utemp;
				}
			}
		}

		return moveidx;
	}

	public static int w_gen_captures(tree_t ptree, int moveidx) {
		bitboard_t bb_movable = new bitboard_t(), bb_capture = new bitboard_t(), bb_piece = new bitboard_t(), bb_desti = new bitboard_t();
		int utemp;
		int ito, ifrom;

		bb_capture = new bitboard_t(ptree.posi.b_occupied);
		bitop.BBNot(bb_movable, ptree.posi.w_occupied);

		bb_desti.p[2] = ptree.posi.w_pawn_attacks.p[2] & bb_movable.p[2];
		bb_desti.p[1] = ptree.posi.w_pawn_attacks.p[1] & bb_capture.p[1];
		bb_desti.p[0] = ptree.posi.w_pawn_attacks.p[0] & bb_capture.p[0];
		while (bitop.BBToU(bb_desti) > 0) {
			ito = bitop.FirstOne(bb_desti);
			bitop.Xor(ito, bb_desti);

			ifrom = ito - 9;
			utemp = (bitop.To2Move(ito) | bitop.From2Move(ifrom)
					| bitop.Cap2Move(ptree.posi.asquare[ito]) | bitop
					.Piece2Move(def.pawn));
			if (ito > def.I4) {
				utemp |= def.FLAG_PROMO;
			}
			ptree.amove[moveidx++] = utemp;
		}

		bb_piece = new bitboard_t(ptree.posi.w_silver);
		while (bitop.BBTest(bb_piece)) {
			ifrom = bitop.FirstOne(bb_piece);
			bitop.Xor(ifrom, bb_piece);

			bitop.BBAnd(bb_desti, bb_capture, data.abb_w_silver_attacks[ifrom]);
			while (bitop.BBTest(bb_desti)) {
				ito = bitop.FirstOne(bb_desti);
				bitop.Xor(ito, bb_desti);

				utemp = (bitop.To2Move(ito) | bitop.From2Move(ifrom)
						| bitop.Cap2Move(ptree.posi.asquare[ito]) | bitop
						.Piece2Move(def.silver));
				if (ito > def.I4 || ifrom > def.I4) {
					ptree.amove[moveidx++] = utemp | def.FLAG_PROMO;
				}
				ptree.amove[moveidx++] = utemp;
			}
		}

		bb_piece = new bitboard_t(ptree.posi.w_tgold);
		while (bitop.BBTest(bb_piece)) {
			ifrom = bitop.FirstOne(bb_piece);
			bitop.Xor(ifrom, bb_piece);

			bitop.BBAnd(bb_desti, bb_capture, data.abb_w_gold_attacks[ifrom]);
			while (bitop.BBTest(bb_desti)) {
				ito = bitop.FirstOne(bb_desti);
				bitop.Xor(ito, bb_desti);

				ptree.amove[moveidx++] = (bitop.To2Move(ito)
						| bitop.From2Move(ifrom)
						| bitop.Cap2Move(ptree.posi.asquare[ito]) | bitop
						.Piece2Move(-ptree.posi.asquare[ifrom]));
			}
		}

		ifrom = ptree.posi.isquare_w_king;
		bitop.BBAnd(bb_desti, bb_capture, data.abb_king_attacks[ifrom]);
		while (bitop.BBTest(bb_desti)) {
			ito = bitop.FirstOne(bb_desti);
			bitop.Xor(ito, bb_desti);

			ptree.amove[moveidx++] = (bitop.To2Move(ito)
					| bitop.From2Move(ifrom)
					| bitop.Cap2Move(ptree.posi.asquare[ito]) | bitop
					.Piece2Move(def.king));
		}

		bb_piece = new bitboard_t(ptree.posi.w_bishop);
		while (bitop.BBTest(bb_piece)) {
			ifrom = bitop.FirstOne(bb_piece);
			bitop.Xor(ifrom, bb_piece);

			bitop.AttackBishop(bb_desti, ifrom, ptree);
			bb_desti.p[2] &= bb_movable.p[2];
			if (ifrom > def.I4) {
				bb_desti.p[1] &= bb_movable.p[1];
				bb_desti.p[0] &= bb_movable.p[0];
			} else {
				bb_desti.p[1] &= bb_capture.p[1];
				bb_desti.p[0] &= bb_capture.p[0];
			}

			while (bitop.BBTest(bb_desti)) {
				ito = bitop.FirstOne(bb_desti);
				bitop.Xor(ito, bb_desti);

				utemp = (bitop.To2Move(ito) | bitop.From2Move(ifrom)
						| bitop.Cap2Move(ptree.posi.asquare[ito]) | bitop
						.Piece2Move(def.bishop));
				if (ito > def.I4 || ifrom > def.I4) {
					utemp |= def.FLAG_PROMO;
				}
				ptree.amove[moveidx++] = utemp;
			}
		}

		bb_piece = new bitboard_t(ptree.posi.w_rook);
		while (bitop.BBTest(bb_piece)) {
			ifrom = bitop.FirstOne(bb_piece);
			bitop.Xor(ifrom, bb_piece);

			bitop.AttackRook(bb_desti, ifrom, ptree);
			bb_desti.p[2] &= bb_movable.p[2];
			if (ifrom > def.I4) {
				bb_desti.p[1] &= bb_movable.p[1];
				bb_desti.p[0] &= bb_movable.p[0];
			} else {
				bb_desti.p[1] &= bb_capture.p[1];
				bb_desti.p[0] &= bb_capture.p[0];
			}

			while (bitop.BBTest(bb_desti)) {
				ito = bitop.FirstOne(bb_desti);
				bitop.Xor(ito, bb_desti);

				utemp = (bitop.To2Move(ito) | bitop.From2Move(ifrom)
						| bitop.Cap2Move(ptree.posi.asquare[ito]) | bitop
						.Piece2Move(def.rook));
				if (ito > def.I4 || ifrom > def.I4) {
					utemp |= def.FLAG_PROMO;
				}
				ptree.amove[moveidx++] = utemp;
			}
		}

		bb_piece = new bitboard_t(ptree.posi.w_horse);
		while (bitop.BBTest(bb_piece)) {
			ifrom = bitop.FirstOne(bb_piece);
			bitop.Xor(ifrom, bb_piece);

			bitop.AttackHorse(bb_desti, ifrom, ptree);
			bitop.BBAnd(bb_desti, bb_desti, bb_capture);
			while (bitop.BBTest(bb_desti)) {
				ito = bitop.FirstOne(bb_desti);
				bitop.Xor(ito, bb_desti);

				ptree.amove[moveidx++] = (bitop.To2Move(ito)
						| bitop.From2Move(ifrom)
						| bitop.Cap2Move(ptree.posi.asquare[ito]) | bitop
						.Piece2Move(def.horse));
			}
		}

		bb_piece = new bitboard_t(ptree.posi.w_dragon);
		while (bitop.BBTest(bb_piece)) {
			ifrom = bitop.FirstOne(bb_piece);
			bitop.Xor(ifrom, bb_piece);

			bitop.AttackDragon(bb_desti, ifrom, ptree);
			bitop.BBAnd(bb_desti, bb_desti, bb_capture);
			while (bitop.BBTest(bb_desti)) {
				ito = bitop.FirstOne(bb_desti);
				bitop.Xor(ito, bb_desti);

				ptree.amove[moveidx++] = (bitop.To2Move(ito)
						| bitop.From2Move(ifrom)
						| bitop.Cap2Move(ptree.posi.asquare[ito]) | bitop
						.Piece2Move(def.dragon));
			}
		}

		bb_piece = new bitboard_t(ptree.posi.w_lance);
		while (bitop.BBTest(bb_piece)) {
			ifrom = bitop.FirstOne(bb_piece);
			bitop.Xor(ifrom, bb_piece);

			bb_desti = new bitboard_t(bitop.AttackFile(ifrom, ptree));
			bitop.BBAnd(bb_desti, bb_desti, data.abb_plus_rays[ifrom]);
			bb_desti.p[2] &= bb_movable.p[2];
			bb_desti.p[1] &= bb_capture.p[1];
			bb_desti.p[0] &= bb_capture.p[0];

			while (bitop.BBTest(bb_desti)) {
				ito = bitop.FirstOne(bb_desti);
				bitop.Xor(ito, bb_desti);

				utemp = (bitop.To2Move(ito) | bitop.From2Move(ifrom)
						| bitop.Cap2Move(ptree.posi.asquare[ito]) | bitop
						.Piece2Move(def.lance));
				if (ito > def.I3) {
					ptree.amove[moveidx++] = utemp | def.FLAG_PROMO;
				} else if (ito > def.I4) {
					ptree.amove[moveidx++] = utemp | def.FLAG_PROMO;
					if (bitop.UToCap(utemp) > 0) {
						ptree.amove[moveidx++] = utemp;
					}
				} else {
					ptree.amove[moveidx++] = utemp;
				}
			}
		}

		bb_piece = new bitboard_t(ptree.posi.w_knight);
		while (bitop.BBTest(bb_piece)) {
			ifrom = bitop.FirstOne(bb_piece);
			bitop.Xor(ifrom, bb_piece);

			bb_desti = new bitboard_t(data.abb_w_knight_attacks[ifrom]);
			bb_desti.p[2] &= bb_movable.p[2];
			bb_desti.p[1] &= bb_capture.p[1];
			bb_desti.p[0] &= bb_capture.p[0];

			while (bitop.BBTest(bb_desti)) {
				ito = bitop.FirstOne(bb_desti);
				bitop.Xor(ito, bb_desti);

				utemp = (bitop.To2Move(ito) | bitop.From2Move(ifrom)
						| bitop.Cap2Move(ptree.posi.asquare[ito]) | bitop
						.Piece2Move(def.knight));
				if (ito > def.I3) {
					ptree.amove[moveidx++] = utemp | def.FLAG_PROMO;
				} else if (ito > def.I4) {
					ptree.amove[moveidx++] = utemp | def.FLAG_PROMO;
					if (bitop.UToCap(utemp) > 0) {
						ptree.amove[moveidx++] = utemp;
					}
				} else {
					ptree.amove[moveidx++] = utemp;
				}
			}
		}

		return moveidx;
	}
}
