public class next {

	public static int gen_next_move(tree_t ptree, int ply, int turn) {

		if (ptree.anext_move[ply].next_phase == def.next_move_hash) {

			// unsigned int * restrict pmove;
			int[] psortv = ptree.sort_value;
			int moveidx;
			int move, killer1, killer2, move_hash, move_best, move_second;
			int i, j, sortv, n, value_best, value_second, value, remaining;

			ptree.anext_move[ply].phase_done = 0;
			ptree.anext_move[ply].next_phase = def.next_move_capture;
			ptree.anext_move[ply].move_last = moveidx = ptree.move_last[ply];
			ptree.move_last[ply] = bitop.GenCaptures(turn, moveidx, ptree);

			move_hash = ptree.amove_hash[ply];
			killer1 = ptree.amove_killer[ply].no1;
			killer2 = ptree.amove_killer[ply].no2;
			remaining = 0;
			move_best = move_second = 0;
			value_best = value_second = 0;
			n = (int) (ptree.move_last[ply] - moveidx);
			for (i = 0; i < n; i++) {
				move = ptree.amove[moveidx + i];
				sortv = swap.swap(ptree, move, -1, Integer.MAX_VALUE, turn);
				if (sortv > value_best) {
					move_second = move_best;
					value_second = value_best;
					value_best = sortv;
					move_best = move;
				} else if (sortv > value_second) {
					move_second = move;
					value_second = sortv;
				}
				if (move == move_hash) {
					sortv = Integer.MIN_VALUE;
				} else if (bitop.UToFromToPromo(move) == killer1) {
					killer1 = 0;
					value = ptree.amove_killer[ply].no1_value
							+ data.p_value_ex[15 + bitop.UToCap(move)];
					if (sortv < value) {
						sortv = value;
					}
					if (sortv > -1) {
						remaining++;
					}
				} else if (bitop.UToFromToPromo(move) == killer2) {
					killer2 = 0;
					value = ptree.amove_killer[ply].no2_value
							+ data.p_value_ex[15 + bitop.UToCap(move)];
					if (sortv < value) {
						sortv = value;
					}
					if (sortv > -1) {
						remaining++;
					}
				} else if (sortv > -1) {
					remaining++;
				}
				psortv[i] = sortv;
			}

			if (killer1 > 0 && killer1 != move_hash
					&& ptree.amove_killer[ply].no1_value > -1
					&& valid.is_move_valid(ptree, killer1, turn) > 0) {
				ptree.amove[ptree.move_last[ply]++] = killer1;
				// *( ptree.move_last[ply]++ ) = killer1;
				psortv[n++] = ptree.amove_killer[ply].no1_value;
				remaining++;
			}

			if (killer2 > 0 && killer2 != move_hash
					&& ptree.amove_killer[ply].no2_value > -1
					&& valid.is_move_valid(ptree, killer2, turn) > 0) {
				ptree.amove[ptree.move_last[ply]++] = killer2;
				psortv[n++] = ptree.amove_killer[ply].no2_value;
				remaining++;
			}

			ptree.anext_move[ply].value_cap1 = value_best;
			ptree.anext_move[ply].move_cap1 = move_best;
			ptree.anext_move[ply].value_cap2 = value_second;
			ptree.anext_move[ply].move_cap2 = move_second;
			ptree.anext_move[ply].remaining = remaining;

			/* insertion sort */
			psortv[n] = Integer.MIN_VALUE;
			for (i = n - 2; i >= 0; i--) {
				sortv = psortv[i];
				move = ptree.amove[moveidx + i];
				for (j = i + 1; psortv[j] > sortv; j++) {
					psortv[j - 1] = psortv[j];
					ptree.amove[moveidx + j - 1] = ptree.amove[moveidx + j];
				}
				psortv[j - 1] = sortv;
				ptree.amove[moveidx + j - 1] = move;
			}
			if (psortv[n - 1] == Integer.MIN_VALUE) {
				ptree.move_last[ply]--;
			}

			if (move_hash > 0
					&& !(valid.is_move_valid(ptree, move_hash, turn) > 0)) {
				// out_warning( "An invalid hash move is found!!" );
				ptree.amove_hash[ply] = move_hash = 0;
			}

			if (move_hash > 0) {
				if (move_hash == move_best) {
					ptree.anext_move[ply].phase_done |= def.phase_cap1;
				}

				if (bitop.UToFromToPromo(move_hash) == killer1) {
					ptree.anext_move[ply].phase_done |= def.phase_killer1;
				} else if (bitop.UToFromToPromo(move_hash) == killer2) {
					ptree.anext_move[ply].phase_done |= def.phase_killer2;
				}
				ptree.anext_move[ply].phase_done |= def.phase_hash;
				ptree.current_move[ply] = move_hash;
				return 1;
			}
		}

		else if (ptree.anext_move[ply].next_phase == def.next_move_capture) {
			if (ptree.anext_move[ply].remaining-- > 0) {
				int move;

				ptree.current_move[ply] = move = ptree.amove[ptree.anext_move[ply].move_last++];
				if (move == ptree.anext_move[ply].move_cap1) {
					ptree.anext_move[ply].phase_done |= def.phase_cap1;
				}

				if (bitop.UToFromToPromo(move) == ptree.amove_killer[ply].no1) {
					ptree.anext_move[ply].phase_done |= def.phase_killer1;
				} else if (bitop.UToFromToPromo(move) == ptree.amove_killer[ply].no2) {
					ptree.anext_move[ply].phase_done |= def.phase_killer2;
				}
				return 1;
			}

			{
				int moveidx;
				int value_best, value, key, good, tried;
				int i, n, ibest;

				value_best = 0;
				ibest = -1;
				ptree.move_last[ply] = bitop.GenNoCaptures(turn,
						ptree.move_last[ply], ptree);
				ptree.move_last[ply] = bitop.GenDrop(turn,
						ptree.move_last[ply], ptree);

				n = (int) (ptree.move_last[ply] - ptree.anext_move[ply].move_last);
				moveidx = ptree.anext_move[ply].move_last;
				for (i = 0; i < n; i++) {
					if (ptree.amove[moveidx + i] == ptree.amove_hash[ply]
							|| (ptree.amove[moveidx + i] == ptree.amove_killer[ply].no1 && (ptree.anext_move[ply].phase_done & def.phase_killer1) > 0)
							|| (ptree.amove[moveidx + i] == ptree.amove_killer[ply].no2 && (ptree.anext_move[ply].phase_done & def.phase_killer2) > 0)) {
						ptree.amove[moveidx + i] = 0;
						continue;
					}

					if (bitop.UToCap(ptree.amove[moveidx + i]) > 0) {
						continue;
					}
					if (bitop.I2IsPromote(ptree.amove[moveidx + i]) > 0
							&& bitop.I2PieceMove(ptree.amove[moveidx + i]) != def.silver) {
						continue;
					}

					key = phash.phash(ptree.amove[moveidx + i], turn);
					good = ptree.hist_good[key] + 1;
					tried = ptree.hist_tried[key] + 2;
					value = (good * 8192) / tried;
					if (value > value_best) {
						value_best = value;
						ibest = i;
					}
				}

				if (ibest >= 0) {
					ptree.anext_move[ply].phase_done |= def.phase_history1;
					ptree.anext_move[ply].next_phase = def.next_move_history2;
					ptree.current_move[ply] = ptree.amove[moveidx + ibest];
					ptree.amove[moveidx + ibest] = 0;
					return 1;
				}
			}
		} else if (ptree.anext_move[ply].next_phase == def.next_move_history2) {
			int moveidx;
			int value_best, value, key, good, tried;
			int ibest, i, n;

			ptree.anext_move[ply].next_phase = def.next_move_misc;
			value_best = 0;
			ibest = -1;
			n = (int) (ptree.move_last[ply] - ptree.anext_move[ply].move_last);
			moveidx = ptree.anext_move[ply].move_last;

			for (i = 0; i < n; i++) {
				if (bitop.UToCap(ptree.amove[moveidx + i]) > 0) {
					continue;
				}
				if (bitop.I2IsPromote(ptree.amove[moveidx + i]) > 0
						&& bitop.I2PieceMove(ptree.amove[moveidx + i]) != def.silver) {
					continue;
				}

				key = phash.phash(ptree.amove[moveidx + i], turn);
				good = ptree.hist_good[key] + 1;
				tried = ptree.hist_tried[key] + 2;
				value = (good * 8192) / tried;
				if (value > value_best && ptree.amove[moveidx + i] > 0) {
					value_best = value;
					ibest = i;
				}
			}

			if (ibest >= 0) {
				ptree.anext_move[ply].phase_done |= def.phase_history2;
				ptree.current_move[ply] = ptree.amove[moveidx + ibest];
				ptree.amove[moveidx + ibest] = 0;
				return 1;
			}
		}

		else {
			assert (ptree.anext_move[ply].next_phase == def.next_move_misc);
			while (ptree.anext_move[ply].move_last < ptree.move_last[ply]) {
				if (ptree.amove[ptree.anext_move[ply].move_last] > 0) {
					ptree.current_move[ply] = ptree.amove[ptree.anext_move[ply].move_last++];
					ptree.anext_move[ply].phase_done |= def.phase_misc;
					return 1;
				}
				ptree.anext_move[ply].move_last++;
			}
		}
		return 0;
	}

	public static int gen_next_evasion(tree_t ptree, int ply, int turn) {
		switch (ptree.anext_move[ply].next_phase) {
		case def.next_evasion_hash:
			ptree.move_last[ply] = bitop.GenEvasion(turn, ptree.move_last[ply],
					ptree);

			if (ptree.amove_hash[ply] > 0) {

				int p;

				for (p = ptree.move_last[ply - 1]; p < ptree.move_last[ply]; p++)
					if (ptree.amove[p] == ptree.amove_hash[ply]) {
						break;
					}

				if (ptree.amove[p] != ptree.amove_hash[ply]) {

					// str_CSA_move(ptree.amove_hash[ply]) );

					ptree.amove_hash[ply] = 0;
				} else

				{
					ptree.anext_move[ply].next_phase = def.next_evasion_genall;
					ptree.current_move[ply] = ptree.amove_hash[ply];
					return 1;
				}
			}

		case def.next_evasion_genall: {
			int moveidx;
			int[] psortv;
			int move;
			int n, i, j, sortv;

			ptree.anext_move[ply].next_phase = def.next_evasion_misc;
			ptree.anext_move[ply].move_last = moveidx = ptree.move_last[ply - 1];
			n = (int) (ptree.move_last[ply] - moveidx);
			psortv = ptree.sort_value;

			for (i = n - 1; i >= 0; i--) {
				move = ptree.amove[moveidx + i];
				if (move == ptree.amove_hash[ply]) {
					sortv = Integer.MIN_VALUE;
					ptree.amove[moveidx + i] = 0;
				} else if (bitop.I2PieceMove(move) == def.king) {
					sortv = data.p_value_ex[bitop.UToCap(move) + 15] * 2;
				} else {
					sortv = swap.swap(ptree, move, Integer.MIN_VALUE,
							Integer.MAX_VALUE, turn);
					sortv += evaldiff.estimate_score_diff(ptree, move, turn);
				}
				psortv[i] = sortv;
			}

			/* insertion sort */
			psortv[n] = Integer.MIN_VALUE;
			for (i = n - 2; i >= 0; i--) {
				sortv = psortv[i];
				move = ptree.amove[moveidx + i];
				for (j = i + 1; psortv[j] > sortv; j++) {
					psortv[j - 1] = psortv[j];
					ptree.amove[moveidx + j - 1] = ptree.amove[moveidx + j];
				}
				psortv[j - 1] = sortv;
				ptree.amove[moveidx + j - 1] = move;
			}
		}

		default:
			assert (ptree.anext_move[ply].next_phase == def.next_evasion_misc);
			while (ptree.anext_move[ply].move_last < ptree.move_last[ply]) {
				if (ptree.amove[ptree.anext_move[ply].move_last] > 0) {
					ptree.current_move[ply] = ptree.amove[ptree.anext_move[ply].move_last++];
					return 1;
				}
				ptree.anext_move[ply].move_last++;
			}
		}
		return 0;
	}

}
