public class valid {
	public static int is_move_valid(tree_t ptree, int move, int turn) {
		int from = (int) bitop.I2From(move);
		int to = (int) bitop.I2To(move);
		int piece_move;
		int u;
		bitboard_t bb = new bitboard_t();

		if (from < def.nsquare) {
			piece_move = (int) bitop.I2PieceMove(move);
			if (turn > 0) {
				if (ptree.posi.asquare[from] != -piece_move) {
					return 0;
				}
				if (ptree.posi.asquare[to] != (int) bitop.UToCap(move)) {
					return 0;
				}
			} else {
				if (ptree.posi.asquare[from] != piece_move) {
					return 0;
				}
				if (ptree.posi.asquare[to] != -(int) bitop.UToCap(move)) {
					return 0;
				}
			}

			switch (piece_move) {
			case 0:
				return 0;

			case def.lance:
			case def.bishop:
			case def.horse:
			case def.rook:
			case def.dragon:
				bitop.BBOr(bb, ptree.posi.b_occupied, ptree.posi.w_occupied);
				bitop.BBAnd(bb, bb, data.abb_obstacle[from][to]);
				if (bitop.BBTest(bb)) {
					return 0;
				}
				break;
			}

			return 1;
		}

		if (ptree.posi.asquare[to] > 0) {
			return 0;
		} else {
			u = turn > 0 ? ptree.posi.hand_white : ptree.posi.hand_black;
			switch (bitop.From2Drop(from)) {
			case def.pawn:
				if (!(bitop.IsHandPawn(u) > 0)) {
					return 0;
				}
				{
					if (turn > 0) {
						u = bitop.BBToU(ptree.posi.w_pawn_attacks);
						if (((def.mask_file1 >> def.aifile[to]) & u) > 0) {
							return 0;
						}
						if (bitop.IsMateWPawnDrop(ptree, to)) {
							return 0;
						}
					} else {
						u = bitop.BBToU(ptree.posi.b_pawn_attacks);
						if (((def.mask_file1 >> def.aifile[to]) & u) > 0) {
							return 0;
						}
						if (bitop.IsMateBPawnDrop(ptree, to)) {
							return 0;
						}
					}
					return 1;
				}
			case def.lance:
				if (bitop.IsHandLance(u) > 0) {
					return 1;
				}
				break;
			case def.knight:
				if (bitop.IsHandKnight(u) > 0) {
					return 1;
				}
				break;
			case def.silver:
				if (bitop.IsHandSilver(u) > 0) {
					return 1;
				}
				break;
			case def.gold:
				if (bitop.IsHandGold(u) > 0) {
					return 1;
				}
				break;
			case def.bishop:
				if (bitop.IsHandBishop(u) > 0) {
					return 1;
				}
				break;
			default:
				assert (bitop.From2Drop(from) == def.rook);
				if (bitop.IsHandRook(u) > 0) {
					return 1;
				}
				break;
			}
		}
		return 0;
	}
}
